/* Utils.c generated by valac 0.56.18, the Vala compiler
 * generated from Utils.vala, do not modify */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <errno.h>
#include <gio/gio.h>

#define UTILS_CONFIG_DEFAULT_MODE UTILS_SCALE_MODES_FILL
#define UTILS_CONFIG_DEFAULT_COLOR "#FFFFFF"
#define CONSTANTS_SETTINGS_WALLPAPER_SCALING_MODE "wallpaper-scaling-mode"
#define CONSTANTS_SETTINGS_WALLPAPER_PATH "wallpaper-path"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	UTILS_SCALE_MODES_FILL = 0,
	UTILS_SCALE_MODES_STRETCH = 1,
	UTILS_SCALE_MODES_FIT = 2,
	UTILS_SCALE_MODES_CENTER = 3
} UtilsScaleModes;

#define UTILS_TYPE_SCALE_MODES (utils_scale_modes_get_type ())

#define UTILS_TYPE_CONFIG (utils_config_get_type ())
typedef struct _UtilsConfig UtilsConfig;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _UtilsConfig {
	gchar* path;
	UtilsScaleModes scale_mode;
	gchar* color;
};

VALA_EXTERN gchar* utils_config_default_path;
gchar* utils_config_default_path = NULL;

VALA_EXTERN GType utils_scale_modes_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* utils_scale_modes_to_string (UtilsScaleModes self);
VALA_EXTERN gchar* utils_scale_modes_to_title (UtilsScaleModes self);
VALA_EXTERN UtilsScaleModes utils_scale_modes_parse_mode (const gchar* value);
VALA_EXTERN GType utils_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UtilsConfig* utils_config_dup (const UtilsConfig* self);
VALA_EXTERN void utils_config_free (UtilsConfig* self);
VALA_EXTERN void utils_config_copy (const UtilsConfig* self,
                        UtilsConfig* dest);
VALA_EXTERN void utils_config_destroy (UtilsConfig* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (UtilsConfig, utils_config_destroy)
VALA_EXTERN void utils_config_init (UtilsConfig *self);
VALA_EXTERN gchar* utils_config_to_string (UtilsConfig *self);
VALA_EXTERN void utils_config_get_color (UtilsConfig *self,
                             GdkRGBA* result);
VALA_EXTERN UtilsScaleModes utils_get_scale_mode_gschema (GSettings* settings);
VALA_EXTERN GVariant* sway_settings_functions_get_gsetting (GSettings* settings,
                                                const gchar* name,
                                                const GVariantType* type);
VALA_EXTERN gchar* utils_get_wallpaper_gschema (GSettings* settings);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
utils_scale_modes_to_string (UtilsScaleModes self)
{
	gchar* result;
#line 9 "../src/Utils.vala"
	switch (self) {
#line 92 "Utils.c"
		default:
#line 9 "../src/Utils.vala"
		case UTILS_SCALE_MODES_FILL:
#line 96 "Utils.c"
		{
			gchar* _tmp0_;
#line 12 "../src/Utils.vala"
			_tmp0_ = g_strdup ("fill");
#line 12 "../src/Utils.vala"
			result = _tmp0_;
#line 12 "../src/Utils.vala"
			return result;
#line 105 "Utils.c"
		}
#line 9 "../src/Utils.vala"
		case UTILS_SCALE_MODES_STRETCH:
#line 109 "Utils.c"
		{
			gchar* _tmp1_;
#line 14 "../src/Utils.vala"
			_tmp1_ = g_strdup ("stretch");
#line 14 "../src/Utils.vala"
			result = _tmp1_;
#line 14 "../src/Utils.vala"
			return result;
#line 118 "Utils.c"
		}
#line 9 "../src/Utils.vala"
		case UTILS_SCALE_MODES_FIT:
#line 122 "Utils.c"
		{
			gchar* _tmp2_;
#line 16 "../src/Utils.vala"
			_tmp2_ = g_strdup ("fit");
#line 16 "../src/Utils.vala"
			result = _tmp2_;
#line 16 "../src/Utils.vala"
			return result;
#line 131 "Utils.c"
		}
#line 9 "../src/Utils.vala"
		case UTILS_SCALE_MODES_CENTER:
#line 135 "Utils.c"
		{
			gchar* _tmp3_;
#line 18 "../src/Utils.vala"
			_tmp3_ = g_strdup ("center");
#line 18 "../src/Utils.vala"
			result = _tmp3_;
#line 18 "../src/Utils.vala"
			return result;
#line 144 "Utils.c"
		}
	}
}

gchar*
utils_scale_modes_to_title (UtilsScaleModes self)
{
	gchar* result;
#line 23 "../src/Utils.vala"
	switch (self) {
#line 155 "Utils.c"
		default:
#line 23 "../src/Utils.vala"
		case UTILS_SCALE_MODES_FILL:
#line 159 "Utils.c"
		{
			gchar* _tmp0_;
#line 26 "../src/Utils.vala"
			_tmp0_ = g_strdup ("Fill Screen");
#line 26 "../src/Utils.vala"
			result = _tmp0_;
#line 26 "../src/Utils.vala"
			return result;
#line 168 "Utils.c"
		}
#line 23 "../src/Utils.vala"
		case UTILS_SCALE_MODES_STRETCH:
#line 172 "Utils.c"
		{
			gchar* _tmp1_;
#line 28 "../src/Utils.vala"
			_tmp1_ = g_strdup ("Stretch Screen");
#line 28 "../src/Utils.vala"
			result = _tmp1_;
#line 28 "../src/Utils.vala"
			return result;
#line 181 "Utils.c"
		}
#line 23 "../src/Utils.vala"
		case UTILS_SCALE_MODES_FIT:
#line 185 "Utils.c"
		{
			gchar* _tmp2_;
#line 30 "../src/Utils.vala"
			_tmp2_ = g_strdup ("Fit Screen");
#line 30 "../src/Utils.vala"
			result = _tmp2_;
#line 30 "../src/Utils.vala"
			return result;
#line 194 "Utils.c"
		}
#line 23 "../src/Utils.vala"
		case UTILS_SCALE_MODES_CENTER:
#line 198 "Utils.c"
		{
			gchar* _tmp3_;
#line 32 "../src/Utils.vala"
			_tmp3_ = g_strdup ("Center Screen");
#line 32 "../src/Utils.vala"
			result = _tmp3_;
#line 32 "../src/Utils.vala"
			return result;
#line 207 "Utils.c"
		}
	}
}

UtilsScaleModes
utils_scale_modes_parse_mode (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 37 "../src/Utils.vala"
	static GQuark _tmp1_label0 = 0;
#line 37 "../src/Utils.vala"
	static GQuark _tmp1_label1 = 0;
#line 37 "../src/Utils.vala"
	static GQuark _tmp1_label2 = 0;
#line 223 "Utils.c"
	UtilsScaleModes result;
#line 37 "../src/Utils.vala"
	_tmp0_ = value;
#line 37 "../src/Utils.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 37 "../src/Utils.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("stretch")))) {
#line 37 "../src/Utils.vala"
		switch (0) {
#line 233 "Utils.c"
			default:
			{
#line 42 "../src/Utils.vala"
				result = UTILS_SCALE_MODES_STRETCH;
#line 42 "../src/Utils.vala"
				return result;
#line 240 "Utils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("fit")))) {
#line 37 "../src/Utils.vala"
		switch (0) {
#line 246 "Utils.c"
			default:
			{
#line 44 "../src/Utils.vala"
				result = UTILS_SCALE_MODES_FIT;
#line 44 "../src/Utils.vala"
				return result;
#line 253 "Utils.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("center")))) {
#line 37 "../src/Utils.vala"
		switch (0) {
#line 259 "Utils.c"
			default:
			{
#line 46 "../src/Utils.vala"
				result = UTILS_SCALE_MODES_CENTER;
#line 46 "../src/Utils.vala"
				return result;
#line 266 "Utils.c"
			}
		}
	} else {
#line 37 "../src/Utils.vala"
		switch (0) {
#line 272 "Utils.c"
			default:
			{
#line 40 "../src/Utils.vala"
				result = UTILS_SCALE_MODES_FILL;
#line 40 "../src/Utils.vala"
				return result;
#line 279 "Utils.c"
			}
		}
	}
}

static GType
utils_scale_modes_get_type_once (void)
{
	static const GEnumValue values[] = {{UTILS_SCALE_MODES_FILL, "UTILS_SCALE_MODES_FILL", "fill"}, {UTILS_SCALE_MODES_STRETCH, "UTILS_SCALE_MODES_STRETCH", "stretch"}, {UTILS_SCALE_MODES_FIT, "UTILS_SCALE_MODES_FIT", "fit"}, {UTILS_SCALE_MODES_CENTER, "UTILS_SCALE_MODES_CENTER", "center"}, {0, NULL, NULL}};
	GType utils_scale_modes_type_id;
	utils_scale_modes_type_id = g_enum_register_static ("UtilsScaleModes", values);
	return utils_scale_modes_type_id;
}

GType
utils_scale_modes_get_type (void)
{
	static volatile gsize utils_scale_modes_type_id__once = 0;
	if (g_once_init_enter (&utils_scale_modes_type_id__once)) {
		GType utils_scale_modes_type_id;
		utils_scale_modes_type_id = utils_scale_modes_get_type_once ();
		g_once_init_leave (&utils_scale_modes_type_id__once, utils_scale_modes_type_id);
	}
	return utils_scale_modes_type_id__once;
}

void
utils_config_init (UtilsConfig *self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 61 "../src/Utils.vala"
	memset (self, 0, sizeof (UtilsConfig));
#line 62 "../src/Utils.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 62 "../src/Utils.vala"
	_tmp1_ = g_build_filename (_tmp0_, "swaysettings-wallpaper", NULL);
#line 62 "../src/Utils.vala"
	_g_free0 (utils_config_default_path);
#line 62 "../src/Utils.vala"
	utils_config_default_path = _tmp1_;
#line 65 "../src/Utils.vala"
	_tmp2_ = g_strdup ("");
#line 65 "../src/Utils.vala"
	_g_free0 ((*self).path);
#line 65 "../src/Utils.vala"
	(*self).path = _tmp2_;
#line 66 "../src/Utils.vala"
	(*self).scale_mode = UTILS_CONFIG_DEFAULT_MODE;
#line 67 "../src/Utils.vala"
	_tmp3_ = g_strdup (UTILS_CONFIG_DEFAULT_COLOR);
#line 67 "../src/Utils.vala"
	_g_free0 ((*self).color);
#line 67 "../src/Utils.vala"
	(*self).color = _tmp3_;
#line 337 "Utils.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 351 "Utils.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 355 "Utils.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 361 "Utils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 366 "Utils.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 372 "Utils.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 376 "Utils.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 380 "Utils.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 384 "Utils.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 388 "Utils.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 392 "Utils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 407 "Utils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 416 "Utils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 423 "Utils.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 429 "Utils.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 437 "Utils.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 441 "Utils.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 447 "Utils.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 452 "Utils.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 458 "Utils.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 462 "Utils.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 466 "Utils.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 472 "Utils.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 478 "Utils.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 490 "Utils.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 494 "Utils.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 498 "Utils.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 503 "Utils.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 511 "Utils.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 529 "Utils.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 535 "Utils.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 539 "Utils.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 547 "Utils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 556 "Utils.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 565 "Utils.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 571 "Utils.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 579 "Utils.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 591 "Utils.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 597 "Utils.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 601 "Utils.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 609 "Utils.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 620 "Utils.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 629 "Utils.c"
	}
}

gchar*
utils_config_to_string (UtilsConfig *self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 71 "../src/Utils.vala"
	_tmp0_ = (*self).path;
#line 71 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 71 "../src/Utils.vala"
	_tmp2_ = utils_scale_modes_to_string ((*self).scale_mode);
#line 71 "../src/Utils.vala"
	_tmp3_ = (*self).color;
#line 71 "../src/Utils.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 71 "../src/Utils.vala"
	_tmp5_ = g_new0 (gchar*, 3 + 1);
#line 71 "../src/Utils.vala"
	_tmp5_[0] = _tmp1_;
#line 71 "../src/Utils.vala"
	_tmp5_[1] = _tmp2_;
#line 71 "../src/Utils.vala"
	_tmp5_[2] = _tmp4_;
#line 71 "../src/Utils.vala"
	_tmp6_ = _tmp5_;
#line 71 "../src/Utils.vala"
	_tmp6__length1 = 3;
#line 71 "../src/Utils.vala"
	_tmp7_ = _vala_g_strjoinv (" ", _tmp6_, (gint) 3);
#line 71 "../src/Utils.vala"
	_tmp8_ = _tmp7_;
#line 71 "../src/Utils.vala"
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/Utils.vala"
	result = _tmp8_;
#line 71 "../src/Utils.vala"
	return result;
#line 679 "Utils.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 696 "Utils.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 723 "Utils.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 729 "Utils.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 735 "Utils.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 739 "Utils.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 747 "Utils.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 751 "Utils.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 763 "Utils.c"
}

static gboolean
int_try_parse (const gchar* str,
               gint* _result_,
               const gchar** unparsed,
               guint _base)
{
	gint _vala__result_ = 0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	glong long_result = 0L;
	gchar* _tmp0_ = NULL;
	glong _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	glong _tmp6_;
	gboolean result;
#line 156 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 158 "glib-2.0.vapi"
	errno = 0;
#line 159 "glib-2.0.vapi"
	_tmp1_ = strtol (str, &_tmp0_, (gint) _base);
#line 159 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 159 "glib-2.0.vapi"
	long_result = _tmp1_;
#line 160 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 160 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 160 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 160 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 161 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 803 "Utils.c"
	} else {
		gchar* _tmp5_;
#line 163 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 163 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 810 "Utils.c"
	}
#line 165 "glib-2.0.vapi"
	_tmp6_ = long_result;
#line 165 "glib-2.0.vapi"
	if ((((glong) G_MININT) <= _tmp6_) && (_tmp6_ <= ((glong) G_MAXINT))) {
#line 816 "Utils.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 166 "glib-2.0.vapi"
		_vala__result_ = (gint) long_result;
#line 167 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 167 "glib-2.0.vapi"
			_tmp8_ = errno != EINVAL;
#line 825 "Utils.c"
		} else {
#line 167 "glib-2.0.vapi"
			_tmp8_ = FALSE;
#line 829 "Utils.c"
		}
#line 167 "glib-2.0.vapi"
		if (_tmp8_) {
#line 833 "Utils.c"
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 167 "glib-2.0.vapi"
			_tmp9_ = _vala_unparsed;
#line 167 "glib-2.0.vapi"
			_tmp10_ = endptr;
#line 167 "glib-2.0.vapi"
			_tmp7_ = _tmp9_ != _tmp10_;
#line 842 "Utils.c"
		} else {
#line 167 "glib-2.0.vapi"
			_tmp7_ = FALSE;
#line 846 "Utils.c"
		}
#line 167 "glib-2.0.vapi"
		result = _tmp7_;
#line 167 "glib-2.0.vapi"
		if (_result_) {
#line 167 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 854 "Utils.c"
		}
#line 167 "glib-2.0.vapi"
		if (unparsed) {
#line 167 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 860 "Utils.c"
		}
#line 167 "glib-2.0.vapi"
		return result;
#line 864 "Utils.c"
	} else {
#line 169 "glib-2.0.vapi"
		_vala__result_ = G_MAXINT;
#line 170 "glib-2.0.vapi"
		result = FALSE;
#line 170 "glib-2.0.vapi"
		if (_result_) {
#line 170 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 874 "Utils.c"
		}
#line 170 "glib-2.0.vapi"
		if (unparsed) {
#line 170 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 880 "Utils.c"
		}
#line 170 "glib-2.0.vapi"
		return result;
#line 884 "Utils.c"
	}
}

void
utils_config_get_color (UtilsConfig *self,
                        GdkRGBA* result)
{
	GdkRGBA _c = {0};
	gchar* color = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gchar* _tmp15_;
	gint hex_value = 0;
	gboolean _result_ = FALSE;
	const gchar* _tmp16_;
	gint _tmp17_ = 0;
	gboolean _tmp18_;
#line 75 "../src/Utils.vala"
	memset (&_c, 0, sizeof (GdkRGBA));
#line 76 "../src/Utils.vala"
	_tmp0_ = (*self).color;
#line 76 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 76 "../src/Utils.vala"
	color = _tmp1_;
#line 77 "../src/Utils.vala"
	_tmp3_ = color;
#line 77 "../src/Utils.vala"
	_tmp4_ = strlen (_tmp3_);
#line 77 "../src/Utils.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/Utils.vala"
	if (_tmp5_ != 7) {
#line 77 "../src/Utils.vala"
		_tmp2_ = TRUE;
#line 928 "Utils.c"
	} else {
		const gchar* _tmp6_;
#line 77 "../src/Utils.vala"
		_tmp6_ = color;
#line 77 "../src/Utils.vala"
		_tmp2_ = string_get (_tmp6_, (glong) 0) != '#';
#line 935 "Utils.c"
	}
#line 77 "../src/Utils.vala"
	if (_tmp2_) {
#line 939 "Utils.c"
		FILE* _tmp7_;
		FILE* _tmp8_;
		FILE* _tmp9_;
		gchar* _tmp10_;
#line 78 "../src/Utils.vala"
		_tmp7_ = stderr;
#line 78 "../src/Utils.vala"
		fprintf (_tmp7_, "Color not valid! ");
#line 79 "../src/Utils.vala"
		_tmp8_ = stderr;
#line 79 "../src/Utils.vala"
		fprintf (_tmp8_, "Using \"#FFFFFF\". ");
#line 80 "../src/Utils.vala"
		_tmp9_ = stderr;
#line 80 "../src/Utils.vala"
		fprintf (_tmp9_, "Please use this format: \"#RRGGBB\"\n");
#line 81 "../src/Utils.vala"
		_tmp10_ = g_strdup (UTILS_CONFIG_DEFAULT_COLOR);
#line 81 "../src/Utils.vala"
		_g_free0 (color);
#line 81 "../src/Utils.vala"
		color = _tmp10_;
#line 962 "Utils.c"
	}
#line 84 "../src/Utils.vala"
	_tmp11_ = color;
#line 84 "../src/Utils.vala"
	_tmp12_ = color;
#line 84 "../src/Utils.vala"
	_tmp13_ = strlen (_tmp12_);
#line 84 "../src/Utils.vala"
	_tmp14_ = _tmp13_;
#line 84 "../src/Utils.vala"
	_tmp15_ = string_slice (_tmp12_, (glong) 1, (glong) _tmp14_);
#line 84 "../src/Utils.vala"
	_g_free0 (color);
#line 84 "../src/Utils.vala"
	color = _tmp15_;
#line 87 "../src/Utils.vala"
	_tmp16_ = color;
#line 87 "../src/Utils.vala"
	_tmp18_ = int_try_parse (_tmp16_, &_tmp17_, NULL, (guint) 16);
#line 87 "../src/Utils.vala"
	hex_value = _tmp17_;
#line 87 "../src/Utils.vala"
	_result_ = _tmp18_;
#line 88 "../src/Utils.vala"
	if (!_result_) {
#line 88 "../src/Utils.vala"
		*result = _c;
#line 88 "../src/Utils.vala"
		_g_free0 (color);
#line 88 "../src/Utils.vala"
		return;
#line 994 "Utils.c"
	}
#line 89 "../src/Utils.vala"
	_c.alpha = 1.0f;
#line 90 "../src/Utils.vala"
	_c.red = ((hex_value >> 16) & 0xFF) / 255.0f;
#line 91 "../src/Utils.vala"
	_c.green = ((hex_value >> 8) & 0xFF) / 255.0f;
#line 92 "../src/Utils.vala"
	_c.blue = (hex_value & 0xFF) / 255.0f;
#line 93 "../src/Utils.vala"
	*result = _c;
#line 93 "../src/Utils.vala"
	_g_free0 (color);
#line 93 "../src/Utils.vala"
	return;
#line 1010 "Utils.c"
}

void
utils_config_copy (const UtilsConfig* self,
                   UtilsConfig* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 51 "../src/Utils.vala"
	_tmp0_ = (*self).path;
#line 51 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 51 "../src/Utils.vala"
	_g_free0 ((*dest).path);
#line 51 "../src/Utils.vala"
	(*dest).path = _tmp1_;
#line 51 "../src/Utils.vala"
	(*dest).scale_mode = (*self).scale_mode;
#line 51 "../src/Utils.vala"
	_tmp2_ = (*self).color;
#line 51 "../src/Utils.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 51 "../src/Utils.vala"
	_g_free0 ((*dest).color);
#line 51 "../src/Utils.vala"
	(*dest).color = _tmp3_;
#line 1039 "Utils.c"
}

void
utils_config_destroy (UtilsConfig* self)
{
#line 57 "../src/Utils.vala"
	_g_free0 ((*self).path);
#line 59 "../src/Utils.vala"
	_g_free0 ((*self).color);
#line 1049 "Utils.c"
}

UtilsConfig*
utils_config_dup (const UtilsConfig* self)
{
	UtilsConfig* dup;
#line 51 "../src/Utils.vala"
	dup = g_new0 (UtilsConfig, 1);
#line 51 "../src/Utils.vala"
	utils_config_copy (self, dup);
#line 51 "../src/Utils.vala"
	return dup;
#line 1062 "Utils.c"
}

void
utils_config_free (UtilsConfig* self)
{
#line 51 "../src/Utils.vala"
	utils_config_destroy (self);
#line 51 "../src/Utils.vala"
	g_free (self);
#line 1072 "Utils.c"
}

static GType
utils_config_get_type_once (void)
{
	GType utils_config_type_id;
	utils_config_type_id = g_boxed_type_register_static ("UtilsConfig", (GBoxedCopyFunc) utils_config_dup, (GBoxedFreeFunc) utils_config_free);
	return utils_config_type_id;
}

GType
utils_config_get_type (void)
{
	static volatile gsize utils_config_type_id__once = 0;
	if (g_once_init_enter (&utils_config_type_id__once)) {
		GType utils_config_type_id;
		utils_config_type_id = utils_config_get_type_once ();
		g_once_init_leave (&utils_config_type_id__once, utils_config_type_id);
	}
	return utils_config_type_id__once;
}

UtilsScaleModes
utils_get_scale_mode_gschema (GSettings* settings)
{
	GVariant* variant = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GVariant* _tmp3_;
	GVariant* _tmp7_;
	UtilsScaleModes result;
#line 97 "../src/Utils.vala"
	g_return_val_if_fail (settings != NULL, 0);
#line 98 "../src/Utils.vala"
	_tmp0_ = G_VARIANT_TYPE_INT32;
#line 98 "../src/Utils.vala"
	_tmp1_ = sway_settings_functions_get_gsetting (settings, CONSTANTS_SETTINGS_WALLPAPER_SCALING_MODE, _tmp0_);
#line 98 "../src/Utils.vala"
	variant = _tmp1_;
#line 101 "../src/Utils.vala"
	_tmp3_ = variant;
#line 101 "../src/Utils.vala"
	if (_tmp3_ == NULL) {
#line 101 "../src/Utils.vala"
		_tmp2_ = TRUE;
#line 1119 "Utils.c"
	} else {
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
		const GVariantType* _tmp6_;
#line 102 "../src/Utils.vala"
		_tmp4_ = variant;
#line 102 "../src/Utils.vala"
		_tmp5_ = g_variant_get_type (_tmp4_);
#line 102 "../src/Utils.vala"
		_tmp6_ = G_VARIANT_TYPE_INT32;
#line 102 "../src/Utils.vala"
		_tmp2_ = !g_variant_type_equal (_tmp5_, _tmp6_);
#line 1132 "Utils.c"
	}
#line 101 "../src/Utils.vala"
	if (_tmp2_) {
#line 103 "../src/Utils.vala"
		result = 0;
#line 103 "../src/Utils.vala"
		_g_variant_unref0 (variant);
#line 103 "../src/Utils.vala"
		return result;
#line 1142 "Utils.c"
	}
#line 105 "../src/Utils.vala"
	_tmp7_ = variant;
#line 105 "../src/Utils.vala"
	result = (UtilsScaleModes) g_variant_get_int32 (_tmp7_);
#line 105 "../src/Utils.vala"
	_g_variant_unref0 (variant);
#line 105 "../src/Utils.vala"
	return result;
#line 1152 "Utils.c"
}

gchar*
utils_get_wallpaper_gschema (GSettings* settings)
{
	GVariant* variant = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GVariant* _tmp3_;
	GVariant* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 108 "../src/Utils.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 109 "../src/Utils.vala"
	_tmp0_ = G_VARIANT_TYPE_STRING;
#line 109 "../src/Utils.vala"
	_tmp1_ = sway_settings_functions_get_gsetting (settings, CONSTANTS_SETTINGS_WALLPAPER_PATH, _tmp0_);
#line 109 "../src/Utils.vala"
	variant = _tmp1_;
#line 112 "../src/Utils.vala"
	_tmp3_ = variant;
#line 112 "../src/Utils.vala"
	if (_tmp3_ == NULL) {
#line 112 "../src/Utils.vala"
		_tmp2_ = TRUE;
#line 1181 "Utils.c"
	} else {
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
		const GVariantType* _tmp6_;
#line 113 "../src/Utils.vala"
		_tmp4_ = variant;
#line 113 "../src/Utils.vala"
		_tmp5_ = g_variant_get_type (_tmp4_);
#line 113 "../src/Utils.vala"
		_tmp6_ = G_VARIANT_TYPE_STRING;
#line 113 "../src/Utils.vala"
		_tmp2_ = !g_variant_type_equal (_tmp5_, _tmp6_);
#line 1194 "Utils.c"
	}
#line 112 "../src/Utils.vala"
	if (_tmp2_) {
#line 114 "../src/Utils.vala"
		result = NULL;
#line 114 "../src/Utils.vala"
		_g_variant_unref0 (variant);
#line 114 "../src/Utils.vala"
		return result;
#line 1204 "Utils.c"
	}
#line 116 "../src/Utils.vala"
	_tmp7_ = variant;
#line 116 "../src/Utils.vala"
	_tmp8_ = g_variant_get_string (_tmp7_, NULL);
#line 116 "../src/Utils.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 116 "../src/Utils.vala"
	result = _tmp9_;
#line 116 "../src/Utils.vala"
	_g_variant_unref0 (variant);
#line 116 "../src/Utils.vala"
	return result;
#line 1218 "Utils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

